package dev.shadowsoffire.apotheosis.village.wanderer;

import dev.shadowsoffire.placebo.json.NBTAdapter;
import net.minecraft.nbt.CompoundTag;
import dev.shadowsoffire.placebo.json.ItemAdapter;
import net.minecraft.world.item.ItemStack;
import java.lang.reflect.Type;
import net.minecraftforge.common.BasicItemListing;
import com.google.gson.GsonBuilder;
import dev.shadowsoffire.placebo.config.Configuration;
import java.util.Collection;
import net.minecraftforge.event.village.WandererTradesEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import java.util.function.Consumer;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import com.google.gson.Gson;
import net.minecraftforge.fml.common.Mod;

@Mod.EventBusSubscriber(modid = "apotheosis", bus = Mod.EventBusSubscriber.Bus.MOD)
public class WandererReplacements
{
    public static boolean clearNormTrades;
    public static boolean clearRareTrades;
    public static boolean undergroundTrader;
    public static int wandererMaxChance;
    public static int wandererRngCoeff;
    public static int despawnDelay;
    public static final Gson GSON;
    
    @SubscribeEvent
    public static void setup(final FMLCommonSetupEvent e) {
        WandererTradesRegistry.INSTANCE.registerToBus();
        MinecraftForge.EVENT_BUS.addListener((Consumer)WandererReplacements::replaceWandererArrays);
    }
    
    public static void replaceWandererArrays(final WandererTradesEvent e) {
        if (WandererReplacements.clearNormTrades) {
            e.getGenericTrades().clear();
        }
        if (WandererReplacements.clearRareTrades) {
            e.getRareTrades().clear();
        }
        e.getGenericTrades().addAll(WandererTradesRegistry.INSTANCE.getNormalTrades());
        e.getRareTrades().addAll(WandererTradesRegistry.INSTANCE.getRareTrades());
    }
    
    public static void load(final Configuration cfg) {
        WandererReplacements.clearNormTrades = cfg.getBoolean("Clear Generic Trades", "wanderer", WandererReplacements.clearNormTrades, "If the generic trade list will be cleared before datapack loaded trades are added.\nServer-authoritative.");
        WandererReplacements.clearRareTrades = cfg.getBoolean("Clear Rare Trades", "wanderer", WandererReplacements.clearRareTrades, "If the rare trade list will be cleared before datapack loaded trades are added.\nServer-authoritative.");
        WandererReplacements.undergroundTrader = cfg.getBoolean("Underground Trader", "wanderer", WandererReplacements.undergroundTrader, "If the Wandering Trader can attempt to spawn underground.\nServer-authoritative.");
    }
    
    static {
        WandererReplacements.clearNormTrades = false;
        WandererReplacements.clearRareTrades = false;
        WandererReplacements.undergroundTrader = true;
        WandererReplacements.wandererMaxChance = 101;
        WandererReplacements.wandererRngCoeff = 2;
        WandererReplacements.despawnDelay = 24000;
        GSON = new GsonBuilder().setPrettyPrinting().registerTypeAdapter(BasicItemListing.class, BasicItemListingAdapter.INSTANCE).registerTypeAdapter(ItemStack.class, ItemAdapter.INSTANCE).registerTypeAdapter(CompoundTag.class, NBTAdapter.INSTANCE).create();
    }
}
